from sklearn.cluster import KMeans
from sklearn.metrics import silhouette_score, silhouette_samples
from sklearn.feature_extraction.text import TfidfTransformer
from sklearn.cluster import AgglomerativeClustering
import matplotlib.pyplot as plt
import matplotlib.cm as cm
import numpy as np
import csv



def load_data(filename):
    infile_opener = open(filename, 'r')
    infile_reader = csv.reader(infile_opener)
    
    rownum = 0
    data = []

    for row in infile_reader:
        if rownum == 0:
            pass
        elif rownum < 3000:
            row = row[1:11]
            row = map(int, row)
            data.append(row)
        rownum += 1

    infile_opener.close()
    data = np.asarray(data)
    return data

def PrintInfo(method, c_num, labels, silScore):
  label_file_name = method + '_label_k=' + str(c_num) + '.txt'
  file_opener = open(label_file_name, 'w')

  # for i in range(0, c_num):
  #   file_opener.write('n = ' + str(i) + ' ')
  #   file_opener.write(str(len([j for j,val in enumerate(labels) if val==i])))
  #   file_opener.write('\n')

  file_opener.write('Sil Score = ' + str(silScore))

  file_opener.close()


def KMeans_Clustering():
  # read in raw data
  raw_infile_name = 'Error_Machines.csv'
  raw_data = load_data(raw_infile_name)

  # perform TfIDF on raw_data, write your code here
  tfidf_data = None

  tfidf_data = tfidf_data.toarray()
  np.save('TFIDF_Raw_Data.npy', tfidf_data)

  # perform kMeans Clustering, set max iteration to be 5000, n_init to be 1, initialize using kmeans++, random_state to be 0
  # c_num is the cluster number, we experiment for cluster number from 2 to 9
  score = []
  for c_num in range(2,10):

    #Get the kMeans Model, write your code here
    kMeans_Model = None 
    
    #Get the labels, write your code here
    kMeans_cluster_labels = None

    #Calculate silhouette score for kMeans, using Euclidean distance,  write your code here
    kMeans_silScore = None
    score.append(kMeans_silScore)
  

    print 'KMeans ' + 'k = ' + str(c_num) + ' Finished!'

  with open('kmeans_report.txt', 'w') as f:
    f.write('\n'.join(map(str, score)))



def Hierarchical_Clustering():
  # Load the tfidf data from KMeans Clustering
  tfidf_data = np.load('TFIDF_Raw_Data.npy')

  # Aggolomerative Clustering Model, clustering number from 2 to 9
  score = []
  for c_num in range(2,10):
    #Build the Model, using complete linkage and  euclidean distance, write your code here
    agoCluster_LinkComp_Model = None
    
    #Get the labels, write your code here
    agoCluster_LinkComp_labels = None

    #Calculate silhouette score for aggolomerative Clustering, using Euclidean distance, write your code here
    agoCluster_LinkComp_silScore = None

    score.append(agoCluster_LinkComp_silScore)
    print 'agoCluster_LinkComplete ' + 'k = ' + str(c_num) + ' Finished!'

  with open('hierarchicalClustering_report.txt', 'w') as f:
    f.write('\n'.join(map(str, score)))


if __name__ == "__main__":

  KMeans_Clustering()
  Hierarchical_Clustering()


